import { __assign, __awaiter, __generator } from "tslib";
// Initializers
import * as vuex from "./plugin/initializers/store";
import MetaInfo from "vue-meta-info";
import wordpress from './mixins/wordpress';
export var ModulePrefix = "wp";
export default {
    install: function (Vue, options) {
        return __awaiter(this, void 0, void 0, function () {
            var store, manualVuexMode, nuxtServer, html, el, url, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        // Config
                        // Is it proper
                        // if (!('config' in options)) {
                        //   throw new Error('No config provided!')
                        // }
                        if (!("url" in options)) {
                            throw new Error("No API's URL provided!");
                        }
                        if (!("lang" in options)) {
                            throw new Error("No lang provided!");
                        }
                        // Register it in app
                        Vue.use(MetaInfo);
                        Vue.mixin(wordpress);
                        // Do we have store?
                        if (!("store" in options)) {
                            throw new Error("No VueX store provided in config!");
                        }
                        store = void 0;
                        manualVuexMode = options.store === true;
                        if (!!manualVuexMode) return [3 /*break*/, 2];
                        store = options.store;
                        vuex.registerModules(store);
                        vuex.setConfig(store.commit, __assign(__assign(__assign(__assign({ url: options.url, lang: options.lang }, (options.requestPrefix ? { requestPrefix: options.requestPrefix } : {})), (options.menus ? { menus: options.menus } : {})), (options.titleTemplate ? { titleTemplate: options.titleTemplate } : {})), (options.debugger ? { debugger: options.debugger } : {})));
                        return [4 /*yield*/, vuex.loadBase(store.dispatch, options.hasOwnProperty("menus") ? options.menus : true)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        nuxtServer = process && process.server;
                        if (!nuxtServer && document !== undefined) {
                            html = document.querySelector("html");
                            if (html) {
                                html.setAttribute("lang", options.lang);
                            }
                            el = document.createElement("link");
                            el.setAttribute("rel", "alternate");
                            url = window.location.origin.substr(-1) === "/"
                                ? window.location.origin
                                : window.location.origin + "/";
                            el.setAttribute("href", "" + url + options.lang);
                            el.setAttribute("hreflang", "" + options.lang);
                            document.head.appendChild(el);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1, e_1.message);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=index.js.map