import { __read, __spread, __values } from "tslib";
import { isLoaderRequestElement } from "../types";
var pickMetaSource = function (loaderRequest) {
    var e_1, _a;
    var type = "pages";
    if (typeof loaderRequest === "string") {
        return {
            slug: loaderRequest,
            type: type
        };
    }
    else if (isLoaderRequestElement(loaderRequest)) {
        if (loaderRequest.hasOwnProperty("type")) {
            type = loaderRequest.type;
        }
        return {
            slug: "dataName" in loaderRequest
                ? loaderRequest.dataName
                : loaderRequest.slug,
            type: type
        };
    }
    else if (Array.isArray(loaderRequest)) {
        var current = null;
        var reversedLoader = __spread(loaderRequest).reverse();
        try {
            for (var reversedLoader_1 = __values(reversedLoader), reversedLoader_1_1 = reversedLoader_1.next(); !reversedLoader_1_1.done; reversedLoader_1_1 = reversedLoader_1.next()) {
                var request = reversedLoader_1_1.value;
                var tmp = pickMetaSource(request);
                if (current === null) {
                    current = tmp;
                }
                if (isLoaderRequestElement(request) &&
                    "meta" in request &&
                    request.meta === true) {
                    return tmp;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (reversedLoader_1_1 && !reversedLoader_1_1.done && (_a = reversedLoader_1.return)) _a.call(reversedLoader_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return current;
    }
    else {
        throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
    }
};
export default pickMetaSource;
//# sourceMappingURL=PickMetaSource.js.map