import { __read, __spread } from "tslib";
import ResolveRoute from "../util/ResolveRoute";
export default (function (type, key, metaConfig) { return ({
    metaInfo: function () {
        var plainObject = ResolveRoute(key, this.$route);
        if (this[plainObject] !== false && this[plainObject]) {
            var source = this[plainObject]._embedded &&
                this[plainObject]._embedded["wp:featuredmedia"] &&
                this[plainObject]._embedded["wp:featuredmedia"][0].media_details
                ? this[plainObject]._embedded["wp:featuredmedia"][0].media_details
                : null;
            var dt = [];
            if (source && source.sizes) {
                var altText = this[plainObject]._embedded["wp:featuredmedia"][0]
                    .alt_text;
                var medium = source.sizes.hasOwnProperty("large")
                    ? source.sizes.large
                    : Object.values(source.sizes).reverse()[0];
                var mimeType = medium.mime_type.split("/")[0];
                switch (mimeType) {
                    case "image":
                        dt.push({ property: "og:image", content: medium.source_url }, { name: "twitter:image", content: medium.source_url }, { name: "twitter:card", content: "summary_large_image" }, { property: "og:image:url", content: medium.source_url }, {
                            property: "og:image:width",
                            content: medium.width
                        }, {
                            property: "og:image:height",
                            content: medium.height
                        }, { property: "og:image:type", content: medium.mime_type });
                        if (altText && altText.length > 0) {
                            dt.push({ property: "og:image:alt", content: altText });
                        }
                        break;
                    case "video":
                        // TODO
                        // dt.push(
                        //   { property: "og:video", content: medium.guid.rendered },
                        //   {
                        //     property: "og:video:type",
                        //     content: medium.media_details.mime_type
                        //   },
                        //   {
                        //     property: "og:video:width",
                        //     content: medium.media_details.width
                        //   },
                        //   {
                        //     property: "og:video:height",
                        //     content: medium.media_details.height
                        //   },
                        //   { property: "og:video:alt", content: medium.alt_text }
                        // );
                        break;
                }
            }
            var description = this[plainObject] &&
                this[plainObject].excerpt &&
                this[plainObject].excerpt.rendered &&
                this[plainObject].excerpt.rendered.length > 0
                ? {
                    vmid: "description",
                    name: "description",
                    content: this[plainObject].excerpt.rendered.replace(/<(?:.|\n)*?>/gm, "")
                }
                : {};
            var ogDesc = [];
            if ("content" in description) {
                ogDesc.push({ property: "og:description", content: description.content }, { name: "twitter:description", content: description.content });
            }
            var title = this[plainObject].title.rendered;
            var customTitle = false;
            if (metaConfig) {
                if (metaConfig.hasOwnProperty("titleTemplate")) {
                    title = metaConfig.titleTemplate.replace("%s", title);
                    customTitle = true;
                }
            }
            if (!customTitle && this.$wp.titleTemplate) {
                title = this.$wp.titleTemplate.replace("%s", title);
            }
            return {
                title: title,
                meta: __spread([
                    description,
                    { property: "og:title", content: this[plainObject].title.rendered },
                    { name: "twitter:title", content: this[plainObject].title.rendered }
                ], ogDesc, dt, [
                    { property: "og:type", content: type },
                    { charset: "UTF-8" }
                ])
            };
        }
        else {
            return {
                meta: [{ charset: "UTF-8" }]
            };
        }
    }
}); });
//# sourceMappingURL=meta.js.map