import { __assign, __awaiter, __generator, __values } from "tslib";
import { isLoaderRequestElement, FetchHookTypes } from "../../../types";
import { ModulePrefix } from "../../../";
import ResolveRoute from '../../../util/ResolveRoute';
var buildAsyncData = function (loaderRequest, fht) {
    if (fht === void 0) { fht = FetchHookTypes.AsyncData; }
    return function (_a) {
        var store = _a.store, route = _a.route;
        return __awaiter(this, void 0, void 0, function () {
            var resolvedLoaderRequest, isPost, contentType, resolvedLoaderRequest, dataName, response, loaderRequest_1, loaderRequest_1_1, request, localResponse, e_1_1;
            var _b, _c, e_1, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (!(typeof loaderRequest === "string")) return [3 /*break*/, 2];
                        resolvedLoaderRequest = ResolveRoute(loaderRequest, route);
                        return [4 /*yield*/, store.dispatch(ModulePrefix + "_post/load", {
                                slug: resolvedLoaderRequest,
                                type: "pages",
                                embed: false
                            })];
                    case 1:
                        _e.sent();
                        if (fht === FetchHookTypes.AsyncData) {
                            return [2 /*return*/, (_b = {},
                                    _b[resolvedLoaderRequest] = store.state[ModulePrefix + "_post"].types.pages[resolvedLoaderRequest]
                                        ? store.state[ModulePrefix + "_post"].types.pages[resolvedLoaderRequest]
                                        : null,
                                    _b)];
                        }
                        return [3 /*break*/, 14];
                    case 2:
                        if (!isLoaderRequestElement(loaderRequest)) return [3 /*break*/, 4];
                        isPost = "type" in loaderRequest && loaderRequest.type;
                        contentType = isPost ? loaderRequest.type : "pages";
                        resolvedLoaderRequest = ResolveRoute(loaderRequest.slug, route);
                        return [4 /*yield*/, store.dispatch(ModulePrefix + "_post/load", {
                                slug: resolvedLoaderRequest,
                                type: contentType,
                                embed: loaderRequest.hasOwnProperty('embed')
                            })];
                    case 3:
                        _e.sent();
                        if (fht === FetchHookTypes.AsyncData) {
                            dataName = "dataName" in loaderRequest && loaderRequest.dataName
                                ? loaderRequest.dataName
                                : resolvedLoaderRequest;
                            return [2 /*return*/, (_c = {},
                                    _c[dataName] = store.state[ModulePrefix + "_post"].types[contentType][resolvedLoaderRequest]
                                        ? store.state[ModulePrefix + "_post"].types[contentType][resolvedLoaderRequest]
                                        : null,
                                    _c)];
                        }
                        return [3 /*break*/, 14];
                    case 4:
                        if (!Array.isArray(loaderRequest)) return [3 /*break*/, 13];
                        response = {};
                        _e.label = 5;
                    case 5:
                        _e.trys.push([5, 10, 11, 12]);
                        loaderRequest_1 = __values(loaderRequest), loaderRequest_1_1 = loaderRequest_1.next();
                        _e.label = 6;
                    case 6:
                        if (!!loaderRequest_1_1.done) return [3 /*break*/, 9];
                        request = loaderRequest_1_1.value;
                        if (typeof request !== "string" && !isLoaderRequestElement(request)) {
                            throw new Error("FetchHookTypeVoidAsyncData: Bad loaderRequest");
                        }
                        return [4 /*yield*/, buildAsyncData
                                .call(this, request, FetchHookTypes.AsyncData)
                                .call(this, { store: store })];
                    case 7:
                        localResponse = _e.sent();
                        response = __assign(__assign({}, response), localResponse);
                        _e.label = 8;
                    case 8:
                        loaderRequest_1_1 = loaderRequest_1.next();
                        return [3 /*break*/, 6];
                    case 9: return [3 /*break*/, 12];
                    case 10:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 12];
                    case 11:
                        try {
                            if (loaderRequest_1_1 && !loaderRequest_1_1.done && (_d = loaderRequest_1.return)) _d.call(loaderRequest_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 12: return [2 /*return*/, response];
                    case 13: throw new Error("FetchHookTypeVoidAsyncData: loaderRequest cannot be " +
                        typeof loaderRequest);
                    case 14: return [2 /*return*/];
                }
            });
        });
    };
};
export default buildAsyncData;
//# sourceMappingURL=AsyncData.js.map