import { __assign, __values } from "tslib";
import { isLoaderRequestElement } from "../../../types";
import { ModulePrefix } from "../../../";
import ResolveRoute from '../../../util/ResolveRoute';
var buildComputed = function (loaderRequest) {
    var e_1, _a;
    var computed = {};
    if (typeof loaderRequest === "string") {
        if (loaderRequest.trim() !== '') {
            computed[loaderRequest] = function () {
                return this.$store.state[ModulePrefix + "_post"].types.hasOwnProperty("pages") && this.$store.state[ModulePrefix + "_post"].types.pages[loaderRequest]
                    ? this.$store.state[ModulePrefix + "_post"].types.pages[loaderRequest]
                    : null;
            };
        }
        return computed;
    }
    else if (isLoaderRequestElement(loaderRequest)) {
        var contentType_1 = "type" in loaderRequest ? loaderRequest.type : "pages";
        var dataName = "dataName" in loaderRequest ? loaderRequest.dataName : loaderRequest.slug;
        if (dataName.trim() !== '') {
            if (loaderRequest.slug === '') {
                computed[dataName] = function () {
                    return this.$store.state[ModulePrefix + "_post"].types[contentType_1] &&
                        this.$store.state[ModulePrefix + "_post"].types[contentType_1]
                        ? this.$store.state[ModulePrefix + "_post"].types[contentType_1]
                        : null;
                };
            }
            else {
                computed[dataName] = function () {
                    return this.$store.state[ModulePrefix + "_post"].types[contentType_1] &&
                        this.$store.state[ModulePrefix + "_post"].types[contentType_1][ResolveRoute(loaderRequest.slug, this.$route)]
                        ? this.$store.state[ModulePrefix + "_post"].types[contentType_1][ResolveRoute(loaderRequest.slug, this.$route)]
                        : null;
                };
            }
        }
        return computed;
    }
    else if (Array.isArray(loaderRequest)) {
        try {
            for (var loaderRequest_1 = __values(loaderRequest), loaderRequest_1_1 = loaderRequest_1.next(); !loaderRequest_1_1.done; loaderRequest_1_1 = loaderRequest_1.next()) {
                var request = loaderRequest_1_1.value;
                computed = __assign(__assign({}, computed), buildComputed.call(this, request));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (loaderRequest_1_1 && !loaderRequest_1_1.done && (_a = loaderRequest_1.return)) _a.call(loaderRequest_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    else {
        throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
    }
    return computed;
};
export default buildComputed;
//# sourceMappingURL=Computed.js.map