import { __awaiter, __generator, __read, __values } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
var currentlyFetching = {};
var beforeMark = function (baseUrl, content) {
    return "" + (baseUrl.includes('?') ? '&' : '?') + content;
};
export var actions = {
    load: function (_a, _b) {
        var commit = _a.commit, rootState = _a.rootState, state = _a.state;
        var slug = _b.slug, _c = _b.type, type = _c === void 0 ? 'pages' : _c, _d = _b.embed, embed = _d === void 0 ? false : _d, _e = _b.per_page, per_page = _e === void 0 ? null : _e, _f = _b.fields, fields = _f === void 0 ? [] : _f, _g = _b.beforeSave, beforeSave = _g === void 0 ? null : _g, _h = _b.beforeRequest, beforeRequest = _h === void 0 ? null : _h, _j = _b.beforeSaveFailed, beforeSaveFailed = _j === void 0 ? null : _j, _k = _b.forceRefetch, forceRefetch = _k === void 0 ? false : _k;
        return __awaiter(this, void 0, void 0, function () {
            var config, typeBaseUrl, requestsAmount, prefix, embedString, halfBase, base, _l, _m, field, requestUrl_1, _o, requestUrl, _p, requests, i, responses, fullResponse, _q, _r, _s, index, response, data, _t, err_1, data, _u;
            var e_1, _v, e_2, _w;
            return __generator(this, function (_x) {
                switch (_x.label) {
                    case 0:
                        config = rootState[ModulePrefix + "_config"];
                        typeBaseUrl = "/wp-json/wp/v2/" + type;
                        requestsAmount = 1;
                        if (config.requestPrefix &&
                            config.requestPrefix.length > 0) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        embedString = embed ? "_embed" : "";
                        halfBase = config.url.endsWith("/")
                            ? config.url.substr(0, config.url.length - 1) + typeBaseUrl
                            : config.url + typeBaseUrl;
                        base = slug === ""
                            ? "" + halfBase + (embedString ? "?" + embedString : embedString)
                            : halfBase + "?slug=" + slug + (embedString ? "&" + embedString : embedString);
                        if (!!fields && !!fields.length) {
                            try {
                                for (_l = __values((Array.isArray(fields) ? fields : [fields])), _m = _l.next(); !_m.done; _m = _l.next()) {
                                    field = _m.value;
                                    base += beforeMark(base, "_fields[]=" + field);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_m && !_m.done && (_v = _l.return)) _v.call(_l);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                        if (!!fields.length && !fields.includes('slug')) {
                            base += beforeMark(base, '_fields[]=slug');
                        }
                        // Pagination
                        if (!!per_page) {
                            if (per_page > 100) {
                                requestsAmount = Math.max(1, Math.ceil(per_page / 100));
                                per_page = 100;
                            }
                            if (config.debugger) {
                                if (per_page > 100) {
                                    console.log("[VueWordpress][Debugger] Per_page's maximum value is 100. It is limit from teh WP Api. So I'll do a " + requestsAmount + " requests");
                                }
                                else if (per_page < 1) {
                                    console.log("[VueWordpress][Debugger] Per_page's minimum value is 1. I've changed it for you to prevent error");
                                }
                            }
                            base += beforeMark(base, "per_page=" + per_page);
                        }
                        _x.label = 1;
                    case 1:
                        _x.trys.push([1, 16, , 20]);
                        if (!((!state.types[type] || !state.types[type][slug]) || forceRefetch)) return [3 /*break*/, 14];
                        if (currentlyFetching && !currentlyFetching[type]) {
                            currentlyFetching[type] = {};
                        }
                        if (!(currentlyFetching && currentlyFetching[type] && currentlyFetching[type][slug])) return [3 /*break*/, 6];
                        if (!config.debugger) return [3 /*break*/, 5];
                        if (!beforeRequest) return [3 /*break*/, 3];
                        return [4 /*yield*/, beforeRequest(base)];
                    case 2:
                        _o = _x.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _o = base;
                        _x.label = 4;
                    case 4:
                        requestUrl_1 = _o;
                        console.log("[VueWordpress][Debugger] Omits " + requestUrl_1 + " because it is being fetched currently");
                        _x.label = 5;
                    case 5: return [2 /*return*/];
                    case 6:
                        if (!beforeRequest) return [3 /*break*/, 8];
                        return [4 /*yield*/, beforeRequest(base)];
                    case 7:
                        _p = _x.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        _p = base;
                        _x.label = 9;
                    case 9:
                        requestUrl = _p;
                        requests = [];
                        for (i = 1; i <= requestsAmount; i++) {
                            requests.push(axios.get(requestUrl + beforeMark(requestUrl, "page=" + i)));
                        }
                        if (!currentlyFetching[type][slug]) {
                            currentlyFetching[type][slug] = true;
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 10:
                        responses = _x.sent();
                        delete currentlyFetching[type][slug];
                        fullResponse = [];
                        try {
                            for (_q = __values(Object.entries(responses)), _r = _q.next(); !_r.done; _r = _q.next()) {
                                _s = __read(_r.value, 2), index = _s[0], response = _s[1];
                                if (config.debugger) {
                                    console.log("[VueWordpress][Debugger] I've just fetched " + (requestUrl + beforeMark(requestUrl, "page=" + (+index + 1))));
                                }
                                if (response.data.status == 404) {
                                    throw new Error("[VueWordpress] Error 404 in " + base + " endpoint");
                                }
                                if (response.data.length < 1) {
                                    throw new Error("[VueWordpress] Empty data in " + base + " endpoint");
                                }
                                fullResponse.push(response.data);
                                if (config.debugger && response.data.some(function (page) { return !page.slug; })) {
                                    console.log("[VueWordpress][Debugger] Some fetched page does not have slug inside. It will cause problem with saving");
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (_r && !_r.done && (_w = _q.return)) _w.call(_q);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        fullResponse = [].concat.apply([], fullResponse);
                        if (!beforeSave) return [3 /*break*/, 12];
                        return [4 /*yield*/, beforeSave(fullResponse)];
                    case 11:
                        _t = _x.sent();
                        return [3 /*break*/, 13];
                    case 12:
                        _t = fullResponse;
                        _x.label = 13;
                    case 13:
                        data = _t;
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [2 /*return*/, data];
                    case 14:
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] Did not fetch " + base + " because it is yet in the store");
                        }
                        _x.label = 15;
                    case 15: return [3 /*break*/, 20];
                    case 16:
                        err_1 = _x.sent();
                        currentlyFetching[type] = currentlyFetching[type].filter(function (currentSlug) { return currentSlug !== slug; });
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] Could not fetch because of error", err_1);
                        }
                        if (!beforeSaveFailed) return [3 /*break*/, 18];
                        return [4 /*yield*/, beforeSaveFailed()];
                    case 17:
                        _u = _x.sent();
                        return [3 /*break*/, 19];
                    case 18:
                        _u = false;
                        _x.label = 19;
                    case 19:
                        data = _u;
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [2 /*return*/, data];
                    case 20: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map